<?
include("./inc/func.php");
include("./inc/tpl.class.php");

/*******************************************************************************
* Order Settings
*******************************************************************************/
$blesta_url = "http://192.168.0.7/api.php"; // The full URL to the API page.
$remote_key = "abcdefg1234567";  // Remote access key as defined in Tools -> Standard Settings.
$emailadmins = "true"; // E-mails admins when a service fails to be added unexpectedly.
$emailreceipt = "true"; // E-mails a receipt to the customer if their card charge is approved.
$autodebit = "true"; // All new accounts have auto debit set to this value.
$title = "Order"; // Title as displayed in the user's browser.
//$module = "cpanel"; // Name of package module to use in this order.

$testmode = "true"; // Note: setting to "false" will not force live mode. If set to "true" will force test mode.
$setasdefault = "true"; // If a user pays with a credit card this will set that contact information as the default billing contact.
$overwrite = "true"; // If a user pays with a credit card and this information matches the first name & last name of a contact already under that account it will overwrite the contact details with the new details, otherwise a new contact will be created.

// Web hosting specific settings
$webhosting = true; // true if this order is for web hosting, false otherwise.
$domain_pid = "41"; // The package ID used to create domain registrations.
$domain_term = "12"; // Ther term used to create domain registrations.

// Errors
$_invalid_coupon = "That coupon code does not exist or is not applicable to that service.";
$_domain_not_available = "That domain is not available.";
$_multiple_users = "Multiple accounts are associated with that E-mail address. Please enter your User ID.";
$_invalid_credentials = "The E-mail/UID and Password combination you entered is invalid.";
$_cc_error = "The Credit Card and/or expiration date you entered appears to be invalid. Please try again.";


// Anti-fraud settings
$fraudcheck_for_creditcards = true; // If set to true, this will make an antifraud API call when a credit card payment is attempted.
$fraudcheck_for_newaccounts = false; // If set to true, this will make an antifraud API call when a service is created for a new account.

/*******************************************************************************
* End Order Settings
*******************************************************************************/

// Start building the template and instantiate the template class
$pdt = new Template("./templates/structure.pdt");
$pdt->set('title', $title);

// Page Contents Template
$pdtc = new Template();


// Jump into the correct step in the order process
switch($_GET['step']) {
     // Choose the plan
     default:
     case "1":
          $pdtcfile = "step1.pdt";
	 // Get Packages
	 $packages = getpackages($blesta_url, $remote_key, $module, true, "active", "true");
	 $pdtc->set('packages', $packages);
	 $pdtc->set('postto', "index.php?step=2");
	 break;
     // Collect information about the service being added
     case "2":
          $pid = false;
          $term = false;
          $coupon = false;

          if ($_GET['pid'] && $_GET['term']) {
               $pid = $_GET['pid'];
               $term = $_GET['term'];
               $coupon = false;
          }
          elseif ($_POST['package']) {
               $temp = explode("-", $_POST['package']);
               $pid = $temp[0];
               $term = $temp[1];
          }


          // We don't have any package information so force the user to step 1.
          if (!$pid || !is_numeric($term)) {
               header("Location: index.php");
               die;
          }

          // Handle coupon requests.
          if ($_REQUEST['coupon']) {
               if (verify_coupon($blesta_url, $remote_key, $_REQUEST['coupon'], $pid))
                    $coupon = $_REQUEST['coupon'];
               else {
                    // The coupon entered is invalid. Send an error.
                    $error = $_invalid_coupon;
               }
          }

          // Fetch the Package
	 $package = getpackage($blesta_url, $remote_key, $pid, $coupon, "active", "true");

          // Verify that the term belongs to this package
          if (!is_array($package['pricing'][$term])) {
               header("Location: index.php");
               die;
          }

          // Get the serviceHTMLFields for this module
          $serviceHTMLFields = getServiceHTMLFields($blesta_url, $remote_key, $package['module']);
          $fields = $serviceHTMLFields['fields'];

          // Place the order data into a base64 serialized array so we can pass
          // it across steps easily.
          $order = base64_encode(serialize(array("term" => $term, "pid" => $pid, "coupon" => $coupon)));

          $pdtcfile = "step2.pdt";
    	 $pdtc->set('postto', "index.php?step=3");
    	 $pdtc->set('package', $package);
    	 $pdtc->set('fields', $fields);
    	 $pdtc->set('webhosting', $webhosting);
    	 $pdtc->set('term', $term);
    	 $pdtc->set('coupon', $coupon);
          $pdtc->set('order', $order);

          if ($error) {
          	$pdtcfile = "step1.pdt";
          	$pdtc->set('postto', "index.php?step=2");
	 	$packages = getpackages($blesta_url, $remote_key, $module, true, "active", "true");
	 	$pdtc->set('packages', $packages);
          }

	 break;
     //  Collect account information or verify an existing account.
     case "3":
          $order = unserialize(base64_decode($_POST['order']));

          $pid = $order['pid'];
          $term = $order['term'];
          $coupon = $order['coupon'];

          // We don't have any package information so force the user to step 1.
          if (!is_numeric($pid) || !is_numeric($term)) {
               header("Location: index.php");
               die;
          }

          // Fetch the Package
	 $package = getpackage($blesta_url, $remote_key, $pid, $coupon, "active", "true");

          // Get the serviceHTMLFields for this module
          $serviceHTMLFields = getServiceHTMLFields($blesta_url, $remote_key, $package['module']);
          $fields = $serviceHTMLFields['fields'];

          // Verify that the term belongs to this package
          if (!is_array($package['pricing'][$term])) {
               header("Location: index.php");
               die;
          }

          // Perform error checking according to the module's regex for each field
          if ($_POST) {
               foreach ($_POST as $key => $value) {
                    if (is_array($value)) {
                         foreach ($value as $subkey => $subvalue) {
                              // search for the matching field
                              for ($i=0; $i<count($fields); $i++) {
                                   // found the field that matches
                                   if ($fields[$i]['dbFieldName'] == $key . "[" . $subkey . "]") {
                                        if (strlen($fields[$i]['regex']) > 0 && !ereg($fields[$i]['regex'], $subvalue)) {
                                             $error = $fields[$i]['errorMessage'];
                                             break 3;
                                        }
                                   }
                              }
                         }
                    }
                    else {
                         // search for the matching field
                         for ($i=0; $i<count($fields); $i++) {
                              // found the field that matches
                              if ($fields[$i]['dbFieldName'] == $key) {
                                   if (strlen($fields[$i]['regex']) > 0 && !ereg($fields[$i]['regex'], $value)) {
                                        $error = $fields[$i]['errorMessage'];
                                        break 2;
                                   }
                              }
                         }
                    }
               }
          }

          // If this is a web hosting order, we may need to verify that the domain is availble
          // to register if the users wishes to do so.
          if (!$error && $webhosting && $_POST['domain'] == "register") {
               // Fetch the Package
	      $domain_package = getpackage($blesta_url, $remote_key, $domain_pid, $coupon, "active", "true");

               // Verify that the term belongs to this package
               if (!is_array($domain_package['pricing'][$domain_term])) {
                    die("Fatal Error: Invalid term set for domain registration.");
               }

               $response = RPC($blesta_url, $remote_key, $domain_package['module'], "checkDomain", $_POST['user1']);

               if ($response['returned'] != "true")
                    $error = $_domain_not_available;
               else {
               	   // Add the domain package to the order array
                    $order['domain_pid'] = $domain_pid;
                    $order['domain_term'] = $domain_term;
               }
          }

          // Add the user1, user2, opt1, opt2, pass fields to the order array
          $order['user1'] = $_POST['user1'];
          $order['user2'] = $_POST['user2'];
          $order['opt1'] = $_POST['opt1'];
          $order['opt2'] = $_POST['opt2'];
          $order['pass'] = $_POST['pass'];

          // Place the order data into a base64 serialized array so we can pass
          // it across steps easily.
          $order = base64_encode(serialize($order));


          $pdtcfile = "step3.pdt";
    	 $pdtc->set('postto', "index.php?step=4");
    	 $pdtc->set('package', $package);
    	 $pdtc->set('term', $term);
          $pdtc->set('webhosting', $webhosting);
          $pdtc->set('coupon', $coupon);
          $pdtc->set('order', $order);

          $locations = getcountriesandstates($blesta_url, $remote_key);
          $pdtc->set('states', $locations['states']);
          $pdtc->set('countries', $locations['countries']);

          if ($_POST['domain'] == "register") {
          	$pdtc->set('domain_term', $domain_term);
                 $pdtc->set('domain_package', $domain_package);
          }


          if ($error) {
          	$pdtcfile = "step2.pdt";
    	 	$pdtc->set('postto', "index.php?step=3");
    	 	$pdtc->set('package', $package);
    	 	$pdtc->set('webhosting', $webhosting);
    	 	$pdtc->set('term', $term);
    	 	$pdtc->set('coupon', $coupon);
          	$pdtc->set('order', $_POST['order']);

                 if ($_POST) {
                         foreach ($_POST as $key => $value) {
                              if (is_array($value)) {
                                   foreach ($value as $subkey => $subvalue) {
                                        // search for the matching field
                                        for ($i=0; $i<count($fields); $i++) {
                                             if ($fields[$i]['dbFieldName'] == $key . "[" . $subkey . "]") {
                                                  $fields[$i]['value'] = $subvalue;
                                                  break; // get the next field
                                             }
                                        }
                                   }
                              }
                              else {
                                   // search for the matching field
                                   for ($i=0; $i<count($fields); $i++) {
                                        if ($fields[$i]['dbFieldName'] == $key) {
                                             $fields[$i]['value'] = $value;
                                             break; // get the next field
                                        }
                                   }
                              }
                         }
                 }
                 $pdtc->set('fields', $fields);
                 $pdtc->set('vars', $_POST);

          }
	 break;
     //  Collect payment information and create services
     case "4":
          $order = unserialize(base64_decode($_POST['order']));

          // We don't have any package information so force the user to step 1.
          if (!is_numeric($order['pid']) || !is_numeric($order['term'])) {
               header("Location: index.php");
               die;
          }

     	 // Attempt to validate the account.
          if ($_GET['type'] == "current") {
	      $client = get_client($blesta_url, $remote_key, $_POST['current']);

               if (is_numeric($client['client']['id']))
               	   $order['uid'] = $client['client']['id'];
               else {
                    if ($client['message'] == "Multiple users returned. Must specify userid.")
               	        $error = $_multiple_users;
                    else
               	        $error = $_invalid_credentials;
               }
          }
          // Attempt to create the account.
          else {
               $account = $_POST['account'];
               $account['coupon'] = $order['coupon'];

               $order['account'] = $_POST['account'];

               #
               # TODO: Error Checking on creating Account
               #

               $result = create_account($blesta_url, $remote_key, $account, $autodebit);

               if (is_numeric($result['uid']))
                    $order['uid'] = $result['uid'];
               else
               	   $error = $result['message'];
          }

	 // Fetch the Package
          if ($order['domain_pid']) {
	 	$domain_package = getpackage($blesta_url, $remote_key, $order['domain_pid'], $order['coupon'], "active", "true", $order['uid']);
	 	$domain_package_calc = getpackage($blesta_url, $remote_key, $order['domain_pid'], $order['coupon'], "active", "false", $order['uid']);
          }

	 // Fetch the Package
	 $package = getpackage($blesta_url, $remote_key, $order['pid'], $order['coupon'], "active", "true", $order['uid']);
	 $package_calc = getpackage($blesta_url, $remote_key, $order['pid'], $order['coupon'], "active", "false", $order['uid']);

          // If we now have a user id we can add the service(s) as PENDING.
          if (is_numeric($order['uid'])) {
               $order['pending'] = "true";
               $order['paid'] = "false";

               if ($order['account'] && $fraudcheck_for_newaccounts) {
	               $input = $order['account'];
	               $input['ip'] = $_SERVER['REMOTE_ADDR'];

	               $fraudcheck = fraudcheck($blesta_url, $remote_key, $input);

	               #
	               # TODO: Evaluate the fraudcheck if you want.  We're just going to
	               # send all that information with the create service call, so it will
	               # be displayed to the admin under the pending service.
	               #
               }
               $order['fraudinfo'] = $fraudcheck['fraudinfo']['rawresponse'];


               // Create the primary service
               $result = create_service($blesta_url, $remote_key, $order);

               // Remove the fraudinfo from the order array, because we don't want the fraudster to see
               // this info
               unset($order['fraudinfo']);


               $orderinfo['pending'][0] = $result['pendingid'];

               $total_due = $package_calc['pricing'][$order['term']]['price'];
               $total_tax = 0.00;
               $taxable = false;
               if ($package_calc['taxable'] == "true") {
                      $total_tax = round($package_calc['pricing'][$order['term']]['price'] * $package_calc['tax']/100, 2);
                      $total_due += $total_tax;
                      $taxable = true;
               }

               $canrecurr = true;
               // Create the secondary service (if it exists)
               if ($domain_package) {
                     // Hold the main package id and term while we create the secondary service.
                     $temp['pid'] = $order['pid'];
                     $temp['term'] = $order['term'];

                     if ($order['term'] != $order['domain_term'])
                     	  $canrecurr = false;
                     
               	    $order['pid'] = $order['domain_pid'];
               	    $order['term'] = $order['domain_term'];

               	    $result = create_service($blesta_url, $remote_key, $order);
               	    $orderinfo['pending'][1] = $result['pendingid'];

                     // Replace the main package id and term.
                     $order['pid'] = $temp['pid'];
                     $order['term'] = $temp['term'];

                     $total_due += $domain_package_calc['pricing'][$order['domain_term']]['price'];
                     if ($domain_package_calc['taxable'] == "true") {
                            $tax = round($domain_package_calc['pricing'][$order['domain_term']]['price'] * $domain_package_calc['tax']/100, 2);
                            $total_tax += $tax;
                            $total_due += $tax;
                            $taxable = true;
                     }
               }

               $order['pending'] = $orderinfo['pending'];

               $orderinfo['uid'] = $order['uid'];

               $orderinfo['amount'] = $total_due;
               $orderinfo['type'] = "all";
               $orderinfo['description'] = $package['name'] . " - " . $order['term'] . " months";
               $orderinfo['coupon'] = $order['coupon'];
               
               if ($canrecurr) {
               	    $orderinfo['recurr']['amount'] = $total_due;
               	    $orderinfo['recurr']['term'] = $order['term'];
               }

               if ($domain_package)
               	     $orderinfo['description'] .= "\n" . $domain_package['name'] . " - " . $order['domain_term'] . " months";

               // Request the payment gateways
               $gateways = get_gateways($blesta_url, $remote_key, $orderinfo);

               if ($gateways['response'] == "error")
                     die($gateways['message']);
          }


          $locations = getcountriesandstates($blesta_url, $remote_key);
          $pdtc->set('states', $locations['states']);
          $pdtc->set('countries', $locations['countries']);

          if ($error) {
               $pdtcfile = "step3.pdt";
    	      $pdtc->set('postto', "index.php?step=4");
    	      $pdtc->set('webhosting', $webhosting);
    	      $pdtc->set('package', $package);
    	      $pdtc->set('term', $order['term']);
               $pdtc->set('coupon', $order['coupon']);
               $pdtc->set('order', $_POST['order']);
               $pdtc->set('current', $_POST['current']);
               $pdtc->set('account', $_POST['account']);

               if ($domain_package) {
          	   $pdtc->set('domain_term', $domain_term);
               	   $pdtc->set('domain_package', $domain_package);
               }
          }
          else {
               $pdtcfile = "step4.pdt";
    	      $pdtc->set('postto', "index.php?step=5");
    	      $pdtc->set('webhosting', $webhosting);
    	      $pdtc->set('package', $package);
    	      $pdtc->set('term', $order['term']);
               $pdtc->set('coupon', $order['coupon']);
               $pdtc->set('order', base64_encode(serialize($order)));
               $pdtc->set('total', format_currency($blesta_url, $remote_key, $total_due, "true"));
               $pdtc->set('total_tax', format_currency($blesta_url, $remote_key, $total_tax, "true"));
               $pdtc->set('taxable', $taxable);

               if ($client)
               	   $billing = $client['client'];
               else
                    $billing = $_POST['account'];

               $pdtc->set('billing', $billing);

               if ($domain_package) {
          	   $pdtc->set('domain_term', $domain_term);
               	   $pdtc->set('domain_package', $domain_package);
               }

               $pdtc->set('gateways', $gateways['gateways']);

          }
    	 break;
     case "5":
          $order = unserialize(base64_decode($_POST['order']));

	 // Fetch the Package
	 $package = getpackage($blesta_url, $remote_key, $order['pid'], $order['coupon'], "active", "true", $order['uid']);
	 $package_calc = getpackage($blesta_url, $remote_key, $order['pid'], $order['coupon'], "active", "false", $order['uid']);

          $total_due = $package_calc['pricing'][$order['term']]['price'];
          $total_tax = 0.00;
          if ($package_calc['taxable'] == "true") {
          	$total_tax = round($package_calc['pricing'][$order['term']]['price'] * $package_calc['tax']/100, 2);
          	$total_due += $total_tax;
          }

	 // Get the price of the secondary item, if it exists
          if ($order['domain_pid']) {
	 	$domain_package = getpackage($blesta_url, $remote_key, $order['domain_pid'], $order['coupon'], "active", "true", $order['uid']);
	 	$domain_package_calc = getpackage($blesta_url, $remote_key, $order['domain_pid'], $order['coupon'], "active", "false", $order['uid']);

                 $total_due += $domain_package_calc['pricing'][$order['domain_term']]['price'];

                 if ($domain_package_calc['taxable'] == "true") {
                        $tax = round($domain_package_calc['pricing'][$order['domain_term']]['price'] * $domain_package_calc['tax']/100, 2);
                        $total_tax += $tax;
                        $total_due += $tax;
                 }
          }

          $paid = false;
          if ($_POST['pay']) {

               $vars = $_POST['billing'];
               $vars['overwrite'] = $overwrite;
               $vars['setasdefault'] = $setasdefault;
               $vars['uid'] = $order['uid'];
               $vars['coupon'] = $order['coupon'];
               $vars['testmode'] = $testmode;

               if ($fraudcheck_for_creditcards) {

	               $input['email'] = $vars['email'];
	               $input['city'] = $vars['city'];
	               $input['state'] = $vars['state'];
	               $input['zip'] = $vars['zip'];
	               $input['country'] = $vars['country'];
	               $input['ccno6'] = substr($vars['ccno'], 0, 6);
	               $input['ip'] = $_SERVER['REMOTE_ADDR'];

	               $fraudcheck = fraudcheck($blesta_url, $remote_key, $input);

	               #
	               # TODO: Evaluate the fraudcheck if you want.  We're just going to
	               # send all that information with update_pending function call, which will
                        # update the pending service as paid. You may wish to modify the update_pending
                        # function so that it only updates the pending service as being paid if you
                        # deem that this payment should be processed based upon the fraudcheck info.
	               #
               }
               $order['fraudinfo'] = $fraudcheck['fraudinfo']['rawresponse'];


               // Process the credit card payment
	      $payment = process_payment($blesta_url, $remote_key, $vars, $total_due, $emailreceipt);

               if ($payment['response'] == "success") {
               	   $paid = true;

                    // Mark these pending services, which have now been paid as being PAID.
                    for ($i=0; $i<count($order['pending']); $i++) {
                    	update_pending($blesta_url, $remote_key, $order['pending'][$i], $order['fraudinfo']);
                    }

               	   // Create the contact that uses the card number given, which was successfully processed.
		   $result = create_contact($blesta_url, $remote_key, $vars);

		   // Update the transaction info and maillog with the correct user id.
		   update_transaction($blesta_url, $remote_key, $order['uid'], $payment['transid'], $payment['mailid'], $result['cid']);
               }
               elseif ($payment['message'] == "Gateway returned an error.")
                    $error = $_cc_error;
               else
                    $error = $payment['message'];
          }

          if ($error) {
               $total_due = format_currency($blesta_url, $remote_key, $total_due, "true");

               $locations = getcountriesandstates($blesta_url, $remote_key);
               $pdtc->set('states', $locations['states']);
               $pdtc->set('countries', $locations['countries']);

               $pdtc->set('postto', "index.php?step=5");
               $pdtcfile = "step4.pdt";
    	      $pdtc->set('postto', "index.php?step=5");
    	      $pdtc->set('webhosting', $webhosting);
    	      $pdtc->set('package', $package);
    	      $pdtc->set('term', $order['term']);
               $pdtc->set('coupon', $order['coupon']);
               $pdtc->set('order', $_POST['order']);
               $pdtc->set('total', $total_due);
               $pdtc->set('billing', $_POST['billing']);

               if ($order['domain_package']) {
          	   $pdtc->set('domain_term', $domain_term);
               	   $pdtc->set('domain_package', $domain_package);
               }

               $orderinfo['uid'] = $order['uid'];
               $orderinfo['amount'] = $total_due;
               $orderinfo['type'] = "all";
               $orderinfo['description'] = $package['name'] . " - " . $order['term'] . " months";
               $orderinfo['coupon'] = $order['coupon'];

               if ($domain_package)
               	     $orderinfo['description'] .= "\n" . $domain_package['name'] . " - " . $order['domain_term'] . " months";

               // Request the payment gateways
               $gateways = get_gateways($blesta_url, $remote_key, $orderinfo);
               $pdtc->set('gateways', $gateways['gateways']);
          }
          else {
               if (!$paid) {
               	  header("Location: index.php");
                   die;
               }

               $pdtcfile = "step5.pdt";
               $pdtc->set('paid', $paid);
          }

     	 break;
}


/*******************************************************************************
  Helper Functions
*******************************************************************************/
// Returns true if it is valid for the given package, returns false otherwise.
function verify_coupon($blesta_url, $remote_key, $code, $pid) {

     $result = getcoupon($blesta_url, $remote_key, false, $code);

     // Verify that the coupon code is active and valid for this package
     if (($result['end'] == "0000-00-00 00:00:00" || $result['end'] >= date('Y-m-d')) && $result['active'] == "1") {
          for ($i=0; $i<count($result['packages']); $i++) {
               if ($result['packages'][$i] == $pid)
                    return true;
          }
     }

     return false;
}


if ($error)
     $pdtc->set('error', $error);
if ($message)
     $pdtc->set('message', $message);

//  Parse and echo the template to the browser
if (is_object($pdt)) {
     $pdt->set('pagecontents', $pdtc->fetch("./templates/" . $pdtcfile));
     echo $pdt->fetch();
}
?>