<?php
/*
*  NOTES ON THIS CRON FILE
*  --
*  1. This file should be run every 15 minutes.
*  2. The key parameter is your Remove Access Key.  You can set this in [Settings] > [API/Cron Settings] > [API Control Options]
*  3. Below is an example of the cron line (for more examples see [Settings] > [API/Cron Settings]):
*     GET -t 15m http://www.yourdomain.com/cronjob.php?key=abcdefg1234567&cron=all > /dev/null 2>&1 &
*/

#$path_to_cron = "../cron/"; // The relative path to your cron directory -- must end with a / (forward slash)

/***************** DO NOT EDIT ANYTHING BELOW THIS LINE ***********************/

set_time_limit(900); // Allow 15-minutes for this script to run

// Check for key passed via command line
if (isset($_SERVER['argc']) && $_SERVER['argc'] > 1) {
	$_GET['key'] = $_SERVER['argv'][1];
	$_GET['cron'] = $_SERVER['argv'][2];
}

if (!$_GET['key'])
	die;

$dir = dirname(__FILE__) . "/";

include($dir . "inc/config.php");
include($dir . "inc/init_lang.php");
include($dir . "inc/mime.class.php");

$path_to_cron = settval($mysqldb, "cronpath");

if (file_exists($path_to_cron))
	$full_path = realpath($path_to_cron) . "/";
else
	die("\$path_to_cron:" . $path_to_cron . " is invalid");

//  Establish a connection to the database.
$mysqldb = new mysql(SQLHOST, SQLUSER, SQLPASS, SQLDB);
$mysqldb->connect();
$mysqldb->select();

// Do key checking
if (!validateKey($mysqldb, $_GET['key']))
	die("Key validation failed.");

logCron($mysqldb, 'attempted');

// Choose the cron to run
switch ($_GET['cron']) {
	case "bill-cron":
		include($full_path . "bill-cron.php");
		break;
	case "suspend":
		include($full_path . "suspend.php");
		break;
	case "db-backup":
		include($full_path . "db-backup.php");
		break;
	case "exchange-rates":
		include($full_path . "exchange-rates.php");
		break;
	case "pop3-tickets":
		include($full_path . "pop3-tickets.php");
		break;
	// Run all crons
	case "all":
	default:
		include($full_path . "bill-cron.php");
		include($full_path . "suspend.php");
		include($full_path . "db-backup.php");
		include($full_path . "exchange-rates.php");
		break;
}
?>