<?php
/*******************************************************************************
 @name CSV
 @author Cody Phillips
 @date February 28, 2008
 @version 1.0
 @notes For use with Blesta version 1.3.0+
*******************************************************************************/
include(ROOTWEBDIR . "inc/export.class.php");

class csv extends AbstractExport {
	private $filename;

	public function __construct() {
		$this->filename = null;
	}

	public function main($vars) {
		// The file name to be used temporarily for writing to, before
		// sending to the browser
		$this->filename = "blesta-" . $vars['type'] . "-" . CURDATETIME . ".csv";

		$invalidFormat = false;
		$format = csv::getFormat($vars);

		// Validate that this format is acceptable to create an CSV from
		//
		// CSV can handle any format, so no need to check.
		//

		if ($invalidFormat)
			throw new Exception(EXPORTINVALIDFORMAT);

		// Format is valid so get the data
		$data = csv::getData($vars);

		// Manipulate data into correct format
		$csv = "";

		// Build the CSV header row
		for ($i=0; $i<count($data['cols']); $i++)
			$csv .= ($i > 0 ? "," : "") . "\"" . str_replace("\"", "\\\"", $data['cols'][$i]) . "\"";
		$csv .= "\n";
		// Build all other rows
		for ($i=0; $i<count($data['rows']); $i++) {
			for ($j=0; $j<count($data['rows'][$i]); $j++)
				$csv .= ($j > 0 ? "," : "") . "\"" . str_replace("\"", "\\\"", $data['rows'][$i][$j]) . "\"";
			$csv .= "\n";
		}

		// Send the file to the browser
		header("Content-type: application/csv");
		header("Content-Disposition: attachment; filename=\"blesta-" . $vars['type'] . "-" . CURDATE . ".csv\"");
		// Here we echo the CSV to the browser.  In some cases it may be necessary to first write the file(s)
		// to the disk before sending them to the browser.  In those cases you should use:
		// writefile($filename, $contents), readFile($filename), and removeFile($filename) respectively.
		echo $csv;
	}
}
?>