<?php
/*******************************************************************************
 @name DialupUSA Module
 @author Cody Phillips
 @date November 9, 2009
 @version 1.2
 @notes For use with Blesta version 1.4.0+
*******************************************************************************/

class dialupusa implements ModuleInterface {
	private static $module;
	
	public function __construct() {
		// Adds a new dialupusa that can be added, edited, or deleted
		dialupusa::$module = new Module("dialupusa", false, true, false);
		
		// Adds the given fields to the database for this module if it has not already
		// been created. WARNING: if the module has already been created with the name
		// given in the Module constructor you must delete the old module before the
		// new one will be created. This may have an adverse effect on services.
		dialupusa::$module->addDBField("varchar(255)", "apiurl", "API", "api.safepages.com/manage.pl");
		dialupusa::$module->addDBField("varchar(255)", "login", "Login", "yourlogin");
		dialupusa::$module->addDBField("varchar(255)", "password", "Password", "yourpassword");
		dialupusa::$module->addDBField("varchar(255)", "realm", "Realm", "yourdomain.com");
		dialupusa::$module->addDBField("varchar(5)", "testmode", "Test Mode", "true");
		
		// Options for updating a new module row, since only one row is needed.
		// NOTE: The HTML Fields will appear in the order defined here on the module setup/edit pages
		dialupusa::$module->addModuleHTMLField("text", "API URL", "apiurl");
		dialupusa::$module->addModuleHTMLField("text", "Login", "login");
		dialupusa::$module->addModuleHTMLField("text", "Password", "password");
		dialupusa::$module->addModuleHTMLField("text", "Realm", "realm");
		dialupusa::$module->addModuleHTMLField("select", "Test Mode", "testmode");
			dialupusa::$module->addModuleHTMLSelectOption("testmode", "Yes", "true");
			dialupusa::$module->addModuleHTMLSelectOption("testmode", "No", "false");
		
		
		// Specify which field from the module table to display in the drop down and give it a friendly name
		// By default items will be shown by ID and have the friendly name of "Module ID".
		// This appears when adding or editing a service for a user.
		dialupusa::$module->setModuleRowSelect("API URL", "apiurl");
		
		// Module Options while creating a package with this module
		// NOTE: Only one field is accepted of this type and must be named "mstring"
		dialupusa::$module->addPackageHTMLField("select", "Use Slipstream", "mstring", "^.+", "You must specify to use slipstream or not.");
			dialupusa::$module->addPackageHTMLSelectOption("mstring", "No", "false");
			dialupusa::$module->addPackageHTMLSelectOption("mstring", "Yes", "true");
		
		
		// These are shown as column names for each service of this type.
		dialupusa::$module->addServiceColumn("user1", "User Name");
		dialupusa::$module->addServiceColumn("pass", "Password");
		
		// These displayed as tags and are usable when creating/editing a packages welcome e-mail
		dialupusa::$module->addServiceTag("user1", "username");
		dialupusa::$module->addServiceTag("pass", "pass");
		
		// These are the fields that may be edited when performing a local edit on this service
		dialupusa::$module->addServiceEditField("user1", "Username");
		dialupusa::$module->addServiceEditField("pass", "Password");
		dialupusa::$module->addServiceEditField("plan", "Package/Term"); // Package/Term
		dialupusa::$module->addServiceEditField("dated", "Date Deleted");
		dialupusa::$module->addServiceEditField("datep", "Date Suspended");
		dialupusa::$module->addServiceEditField("dater", "Date Renews");
		dialupusa::$module->addServiceEditField("notes", "Notes");
		
		
		// Fields that are shown to the admins when adding a service that uses this module from within the control panel
		dialupusa::$module->addServiceHTMLField("text", "User Name", "user1", "^[a-z0-9._-]{1,30}$", "The User Name you entered does not appear to be valid. It should be lowercase.");
		dialupusa::$module->addServiceHTMLField("text", "Password", "pass", "^[^ ]{3,15}$", "Passwords must be between 3 and 15 characters, and must not contain any spaces.");
		
		// Fields that are shown to the user when adding a service that uses this module from within the control panel
		dialupusa::$module->addUserServiceHTMLField("text", "User Name", "user1", "^[a-z0-9._-]{1,30}$", "The User Name you entered does not appear to be valid. It should be lowercase.");
		dialupusa::$module->addUserServiceHTMLField("text", "Password", "pass", "^[^ ]{3,15}$", "Passwords must be between 3 and 15 characters, and must not contain any spaces.");
		
		
		// Creates the module, adds the module to the database if the module table does not
		// already exist. WARNING: if a module has already been created and you attempt to
		// add additional fields they WILL NOT BE ADDED, and any refrence to those fields
		// WILL RESULT IN AN ERROR.
		dialupusa::$module->createModule();
	}
     
	// Returns the module object, this function MUST be present
	public function getModule() {
		return dialupusa::$module;
	}
     
	/*******************************************************************************
	********************************************************************************
	* This is the MAGIC function. This function automatically creates a service    *
	* for a user.                                                                  *
	*                                                                              *
	* IT MUST BE DEFINED HERE OR AN E-MAIL WILL BE SENT TO ALL SUBSCRIBED ADMINS   *
	* NOTIFYING THEM THAT THE SERVICE MUST BE MANUALLY CREATED.                    *
	*                                                                              *
	* IF THIS FUNCTION IS DEFINED AND RETURNS TRUE IT IS ASSUMED THAT IT PERFORMS  *
	* THE NECCESSARY ACTIONS TO AUTOMATICALLY ACTIVATE THE SERVICE.                *
	********************************************************************************
	*******************************************************************************/
	
	public function promodule($action, $serviceInfo, $packageInfo) {
		// packageInfo comes from packagesetinfos() function
		$webaccel = $packageInfo[4][2];
		
		$conditions = array(array("field" => "id", "value" => $serviceInfo['mid']));
		$data = dialupusa::$module->getRows($conditions);
		
		// We are only expecting 1 row returned, so take the first element of this
		// 2-dimensional array
		$apiurl = $data[0]['apiurl'];
		$apilogin = $data[0]['login'];
		$apipass = $data[0]['password'];
		$testmode = $data[0]['testmode'];
		$realm = $data[0]['realm'];
		
		$username = $serviceInfo['user1'];
		$pass = $serviceInfo['pass'];
		$renewdate = $serviceInfo['s_dater'];
		
		// We now have the following vars:
		// $plan, $host, $key, $reselleruser, $usessl $method, $domain, $user, $pass
		
		switch ($action) {
			case "add":
				// When adding a dialup service, the username must be user@domain.com
				// We want this to be the user field in the services table as well
				// so we return $serviceInfo with this real appended
				$serviceInfo['user1'] = $username . "@" . $realm;
		 
				if (DEMO)
					$result = "Sucess!";
				else
					$result = dialupusa::add($apiurl, $apilogin, $apipass, $serviceInfo['user1'], $pass, $webaccel, $testmode);
				//if (eregi("Success!", $result))
				if (preg_match("/Success!/i", $result))
					return $serviceInfo;  // return the info that we want to be inserted into the services table
				break;
			case "remove":

				if (!stristr($username, "@"))
					$username .= "@" . $realm;
				
				if (DEMO)
					$result = "Sucess!";
				else
					$result = dialupusa::remove($apiurl, $apilogin, $apipass, $username, $renewdate, $webaccel, $testmode);
				//if (eregi("Success!", $result))
				if (preg_match("/Success!/i", $result))
					return true;
				break;
			case "suspend":
				
				if (!stristr($username, "@"))
					$username .= "@" . $realm;
				
				if (DEMO)
					$result = "Sucess!";
				else
					$result = dialupusa::suspend($apiurl, $apilogin, $apipass, $username, $testmode);
				//if (eregi("Success!", $result))
				if (preg_match("/Success!/i", $result))
					return true;
				break;
			case "unsuspend":
				
				if (!stristr($username, "@"))
					$username .= "@" . $realm;
				
				if (DEMO)
					$result = "Sucess!";
				else
					$result = dialupusa::unsuspend($apiurl, $apilogin, $apipass, $username, $testmode);
				//if (eregi("Success!", $result))
				if (preg_match("/Success!/i", $result))
					return true;
				break;
		}
		
		return false;
	}
	
	
	/* ------------------------------------------------------------------------------------------------
	  The following are support functions for this module
	--------------------------------------------------------------------------------------------------*/
	private static function add($apiurl, $apilogin, $apipass, $username, $pass, $webaccel, $testmode) {
		$vars = array();
		$vars['login_rid'] = $apilogin;
		$vars['login_pwd'] = $apipass;
		$vars['mode'] = $testmode;
		$vars['action'] = ($webaccel == "true" ? 'webaccel_only_add' : 'dialup_add');
		$vars['username'] = $username;
		$vars['password'] = $pass;
		
		return dialupusa::call($apiurl, $vars);
	}
	private static function remove($apiurl, $apilogin, $apipass, $username, $renewdate, $webaccel, $testmode) {
		$vars = array();
		$vars['login_rid'] = $apilogin;
		$vars['login_pwd'] = $apipass;
		$vars['mode'] = $testmode;
		// Don't set a date yet s_dater is not available to the module yet. $vars['action'] = ($webaccel == "true" ? 'webaccel_schedule_cancel' : 'dialup_schedule_cancel');
		$vars['action'] = ($webaccel == "true" ? 'webaccel_cancel' : 'dialup_cancel');
		// Don't set a date yet: s_dater is not available to the module yet. $vars['date'] = $renewdate; // date to schedule a cancel on
		$vars['username'] = $username;
		
		return dialupusa::call($apiurl, $vars);
	}
	private static function suspend($apiurl, $apilogin, $apipass, $username, $testmode) {
		//echo $testmode;
		$vars = array();
		$vars['login_rid'] = $apilogin;
		$vars['login_pwd'] = $apipass;
		$vars['mode'] = $testmode;
		$vars['action'] = 'dialup_edit_status';
		$vars['status'] = "disabled";
		$vars['username'] = $username;
		
		return dialupusa::call($apiurl, $vars);
	}
	private static function unsuspend($apiurl, $apilogin, $apipass, $username, $testmode) {
		$vars = array();
		$vars['login_rid'] = $apilogin;
		$vars['login_pwd'] = $apipass;
		$vars['mode'] = $testmode;
		$vars['action'] = 'dialup_edit_status';
		$vars['status'] = "enabled";
		$vars['username'] = $username;
		
		return dialupusa::call($apiurl, $vars);
	}
	
	
	// Perform the call action
	private static function call($apiurl, $vars) {
		
		dialupusa::$module->logData($vars, "input", true);
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, "https://" . $apiurl);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $vars);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,0);
		
		$result = curl_exec($ch);
		
		dialupusa::$module->logData($result, "output", (preg_match("/Success!/i", $result) ? true : false));
		
		return $result;
	}
}

?>