<?php
/*******************************************************************************
 @name eNom Module
 @author Cody Phillips
 @date May 18, 2009
 @version 1.0
 @notes For use with Blesta version 2.0.0+
*******************************************************************************/

class enom implements ModuleInterface {
	private static $module;
     
	public function __construct() {
		// Adds a new enom that can be added, edited, or deleted
		enom::$module = new Module("enom", false, true, false);
		
		// Adds the given fields to the database for this module if it has not already
		// been created. WARNING: if the module has already been created with the name
		// given in the Module constructor you must delete the old module before the
		// new one will be created. This may have an adverse effect on services.
		enom::$module->addDBField("varchar(255)", "userid", "User ID");
		enom::$module->addDBField("varchar(255)", "password", "Password");
		enom::$module->addDBField("varchar(5)", "testmode", "Test Mode", "true");
		enom::$module->addDBField("varchar(5)", "lock", "Lock", "true");
		enom::$module->addDBField("varchar(255)", "ns1", "NS1");
		enom::$module->addDBField("varchar(255)", "ns2", "NS2");
		enom::$module->addDBField("varchar(255)", "ns3", "NS3");
		
		
		// Options for creating a new module row
		// Example: eNom module may store multiple different servers. The HTML Fields below
		// allow you to create/edit a server for the enom module
		// NOTE: The HTML Fields will appear in the order defined here on the module setup/edit pages
		enom::$module->addModuleHTMLField("text", "User ID", "userid");
		enom::$module->addModuleHTMLField("text", "Password", "password");
		enom::$module->addModuleHTMLField("select", "Test Mode", "testmode");
			enom::$module->addModuleHTMLSelectOption("testmode", "Yes", "true");
			enom::$module->addModuleHTMLSelectOption("testmode", "No", "false");
		enom::$module->addModuleHTMLField("select", "Lock Domains", "lock");
			enom::$module->addModuleHTMLSelectOption("lock", "Yes", "true");
			enom::$module->addModuleHTMLSelectOption("lock", "No", "false");
		enom::$module->addModuleHTMLField("text", "NS1", "ns1");
		enom::$module->addModuleHTMLField("text", "NS2", "ns2");
		enom::$module->addModuleHTMLField("text", "NS3", "ns3");
		
		
		// Specify which field from the module table to display in the drop down and give it a friendly name
		// By default items will be shown by ID and have the friendly name of "Module ID".
		// This appears when adding or editing a service for a user.
		enom::$module->setModuleRowSelect("eNom Account", "userid");
		
		// If the 3rd parameter is anything other than user1, user2, pass, opt1, opt2, it must be formatted as an element of the detail array.
		// ex. detail[emailaddress].  Note, any field other than user1, user2, pass, opt1, or opt2  will *NOT* be stored in the database,
		// and may only be used in this module file.
		// Fields that are shown to the admins when adding a service that uses this module from within the control panel
		enom::$module->addServiceHTMLField("text", "Domain Name", "user1", "^[a-z0-9._%-]+\.[a-z]{2,6}$", "The Domain Name you entered does not appear to be valid. It should be lowercase and in the format: domain.com.");
		enom::$module->addServiceHTMLField("text", "E-mail Address", "detail[email]", "^[a-z0-9._%-]+@[a-z0-9._%-]+\.[a-z]{2,6}$", "The E-mail address you entered does not appear to be valid.");
		enom::$module->addServiceHTMLField("text", "First Name", "detail[fname]", "^.{2,}", "You must provide a valid First Name.");
		enom::$module->addServiceHTMLField("text", "Last Name", "detail[lname]", "^.{2,}", "You must provide a valid Last Name.");
		enom::$module->addServiceHTMLField("text", "Address 1", "detail[address1]", "^.{2,}", "You must provide a valid Address.");
		enom::$module->addServiceHTMLField("text", "Address 2", "detail[address2]");
		enom::$module->addServiceHTMLField("text", "City", "detail[city]", "^.{2,}", "You must provide a valid City.");
		enom::$module->addServiceHTMLField("text", "State/Province", "detail[state]");
		enom::$module->addServiceHTMLField("text", "Postal Code", "detail[postcode]");
		enom::$module->addServiceHTMLField("text", "Country", "detail[country]", "^[a-zA-z]{3,}", "You must provide a valid Country.");
		enom::$module->addServiceHTMLField("text", "Phone", "detail[phone]", "^[0-9\.\-\(\) ]{7,}", "You must provide a valid Phone Number.");
		enom::$module->addServiceHTMLField("text", "Fax", "detail[fax]");
		enom::$module->addServiceHTMLField("text", "Job Title", "detail[title]");
		enom::$module->addServiceHTMLField("text", "Organization", "detail[org]");
		
		// If the 3rd parameter is anything other than user1, user2, pass, opt1, opt2, then the field created will *NOT* be stored
		// in the database, and may only be used in this module file.
		// Fields that are shown to the user when adding a service that uses this module from within the control panel
		enom::$module->addUserServiceHTMLField("text", "Domain Name", "user1", "^[a-z0-9._%-]+\.[a-z]{2,6}$", "The domain you entered does not appear to be valid. It should be lowercase and in the format: domain.com.");
		enom::$module->addUserServiceHTMLField("text", "E-mail Address", "detail[email]", "^[a-z0-9._%-]+@[a-z0-9._%-]+\.[a-z]{2,6}$", "The E-mail address you entered does not appear to be valid.");
		enom::$module->addUserServiceHTMLField("text", "First Name", "detail[fname]", "^.{2,}", "You must provide a valid First Name.");
		enom::$module->addUserServiceHTMLField("text", "Last Name", "detail[lname]", "^.{2,}", "You must provide a valid Last Name.");
		enom::$module->addUserServiceHTMLField("text", "Address 1", "detail[address1]", "^.{2,}", "You must provide a valid Address.");         
		enom::$module->addUserServiceHTMLField("text", "Address 2", "detail[address2]");
		enom::$module->addUserServiceHTMLField("text", "City", "detail[city]", "^.{2,}", "You must provide a valid City.");
		enom::$module->addUserServiceHTMLField("text", "State/Province", "detail[state]");
		enom::$module->addUserServiceHTMLField("text", "Postal Code", "detail[postcode]");
		enom::$module->addUserServiceHTMLField("text", "Country", "detail[country]", "^[a-zA-z]{3,}", "You must provide a valid Country.");
		enom::$module->addUserServiceHTMLField("text", "Phone", "detail[phone]", "^[0-9\.\-\(\) ]{7,}", "You must provide a valid Phone Number.");
		enom::$module->addUserServiceHTMLField("text", "Fax", "detail[fax]");
		enom::$module->addUserServiceHTMLField("text", "Job Title", "detail[title]");
		enom::$module->addUserServiceHTMLField("text", "Organization", "detail[org]");
		
		// These displayed as tags and are usable when creating/editing a packages welcome e-mail
		enom::$module->addServiceTag("user1", "domain");
		
		// These are the fields that may be edited when performing a local edit on this service
		enom::$module->addServiceEditField("user1", "Domain");
		enom::$module->addServiceEditField("plan", "Package/Term"); // Package/Term
		enom::$module->addServiceEditField("dated", "Date Deleted");
		enom::$module->addServiceEditField("datep", "Date Suspended");
		enom::$module->addServiceEditField("dater", "Date Renews");
		enom::$module->addServiceEditField("notes", "Notes");
		
		// Creates the module, adds the module to the database if the module table does not
		// already exist. WARNING: if a module has already been created and you attempt to
		// add additional fields they WILL NOT BE ADDED, and any refrence to those fields
		// WILL RESULT IN AN ERROR.
		enom::$module->createModule();
	}
     
	// Returns the module object, this function MUST be present
	public function getModule() {
		return enom::$module;
	}
     
     
	/*******************************************************************************
	********************************************************************************
	* This is the MAGIC function. This function automatically creates a service    *
	* for a user.                                                                  *
	*                                                                              *
	* IT MUST BE DEFINED HERE OR AN E-MAIL WILL BE SENT TO ALL SUBSCRIBED ADMINS   *
	* NOTIFYING THEM THAT THE SERVICE MUST BE MANUALLY CREATED.                    *
	*                                                                              *
	* IF THIS FUNCTION IS DEFINED AND RETURNS TRUE IT IS ASSUMED THAT IT PERFORMS  *
	* THE NECCESSARY ACTIONS TO AUTOMATICALLY ACTIVATE THE SERVICE.                *
	********************************************************************************
	*******************************************************************************/
	
	public function promodule($action, $serviceInfo, $packageInfo) {
		$conditions = array(array("field" => "id", "value" => $serviceInfo['mid']));
		$data = enom::$module->getRows($conditions);
	  
		$vars = array();
		// We are only expecting 1 row returned, so take the first element of this
		// 2-dimensional array
		$testmode = $data[0]['testmode'];
		$vars['UID'] = $data[0]['userid'];
		$vars['PW'] = $data[0]['password'];
		$vars['UnLockRegistrar'] = ($data[0]['lock'] == "true" ? 0 : 1); // 1 is unlocked, 0 is locked
		$vars['ResponseType'] = "Text"; // default is text, send HTML or XML for those
	  
	  
		// Extract the SLD and TLD
		preg_match('/^([a-z0-9]+[a-z0-9\-]*[a-z0-9]+)\.([a-z]+[a-z\.]*[a-z]+)$/i', $serviceInfo['user1'], $type);
		$vars['SLD'] = $type[1];
		$vars['TLD'] = $type[2];
	
		switch ($action) {
			case "add":
				$vars['Command'] = "Purchase";
		
				for ($i=1; $i<=3; $i++) {
					if (strlen($data[0]['ns' . $i]) > 0)
						$vars['NS' . $i] = $data[0]['ns' . $i];
				}
		
				// Use the default name servers as set in eNom control panel
				if (!isset($vars['NS1']))
					$vars['UseDNS'] = "default";
		
				// Set co.uk TLD required extended attributes
				switch ($vars['TLD']) {
					case "co.uk":
						// Set legal type as UK individual
						$vars['COUKLegalType'] = "IND";
						$vars['COUKRegisteredfor'] = $serviceInfo['detail']['fname'] . " " . $serviceInfo['detail']['lname'];
						break;
				}
				
				// Must be at least 1 year.
				$vars['NumYears'] = ($serviceInfo['term'] > 12 ? floor($serviceInfo['term']/12) : 1);
				$vars['RegistrantEmailAddress'] = $serviceInfo['detail']['email'];
				$vars['RegistrantFax'] = $serviceInfo['detail']['fax'];
				$vars['RegistrantPhone'] = $serviceInfo['detail']['phone'];
				$vars['RegistrantCountry'] = $serviceInfo['detail']['country'];
				$vars['RegistrantPostalCode'] = $serviceInfo['detail']['postcode'];
				$vars['RegistrantStateProvince'] = $serviceInfo['detail']['state'];
				$vars['RegistrantCity'] = $serviceInfo['detail']['city'];
				$vars['RegistrantAddress1'] = $serviceInfo['detail']['address1'];
				$vars['RegistrantAddress2'] = $serviceInfo['detail']['address2'];
				$vars['RegistrantFirstName'] = $serviceInfo['detail']['fname'];
				$vars['RegistrantLastName'] = $serviceInfo['detail']['lname'];
				$vars['RegistrantJobTitle'] = $serviceInfo['detail']['title'];
				$vars['RegistrantOrganizationName'] = $serviceInfo['detail']['org'];
				$vars['Renewname'] = "1"; // Auto renew the domain name
		
				if (!DEMO && enom::call($vars, $testmode))
					return $serviceInfo;
				break;
			case "remove":
				$vars['Command'] = "SetRenew";
				$vars['RenewFlag'] = "0"; // Turn auto-renew off
		
				if (!DEMO)
					return enom::call($vars, $testmode);
				break;
			case "suspend":
				// No action to perform.
				return true;
				break;
			case "unsuspend":
				// No action to perform.
				return true;
				break;
		}
	
		return false;
	}

	// Checks if the given domain is available through enom
	public function checkDomain($domain) {
		$data = enom::$module->getRows();
	  
		$testmode = $data[0]['testmode'];
		$vars['UID'] = $data[0]['userid'];
		$vars['PW'] = $data[0]['password'];
	  
		// Extract the SLD and TLD
		preg_match('/^([a-z0-9]+[a-z0-9\-]*[a-z0-9]+)\.([a-z]+[a-z\.]*[a-z]+)$/i', $domain, $type);
		$vars['SLD'] = $type[1];
		$vars['TLD'] = $type[2];
		$vars['ResponseType'] = "Text"; // default is text, send HTML or XML for those
		$vars['Command'] = "Check";
	  
		if (enom::call($vars, $testmode))
			return "true";
		return "false";
	}
     
     
	/* ------------------------------------------------------------------------------------------------
   The following are support functions for this module
	--------------------------------------------------------------------------------------------------*/
	// Perform the call action
	private static function call($vars, $testmode) {
		
		// Log data sent to enom
		enom::$module->logData($vars, "input", true);

		if ($testmode == "true")
			$apiurl = "resellertest.enom.com/interface.asp?";
		else
			$apiurl = "reseller.enom.com/interface.asp?";
	  
		$i=0;
		foreach ($vars as $key => $value)
			$apiurl .= ($i++>0 ? "&" : "") . $key . "=" . rawurlencode($value);
	
		$ch = curl_init();
	  
		curl_setopt($ch, CURLOPT_URL, "https://" . $apiurl);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,0);
	  
		$response = curl_exec($ch);
		curl_close ($ch);
	
		//if (eregi("RRPCode=200", $response) || eregi("RRPCode=210", $response) || eregi("Success=True", $response))
		if (preg_match("/RRPCode=200/i", $response) || preg_match("/RRPCode=210/i", $response) || preg_match("/Success=True/i", $response))
			$success = true; // Success
		else
			$success = false;
		
		// Log data received from enom
		enom::$module->logData($response, "output", $success);
	
		return $success;
	}
}
?>