<?php
/*******************************************************************************
 @name OnlineNIC Module
 @author Cody Phillips
 @date July 22, 2010
 @version 1.2
 @notes For use with Blesta version 2.0.0+
*******************************************************************************/

class onlinenic implements ModuleInterface {
	private static $module;
	private static $live_url = "www.onlinenic.com";
	private static $test_url = "218.5.81.149";
	private static $port = "20001";
	private static $test_login = "135610";
	private static $test_password = "654123";
	private $fp; // Hold this module's file pointer resource

	public function __construct() {
		// Adds a new onlinenic that can be added, edited, or deleted
		onlinenic::$module = new Module("onlinenic", false, true, false);

		// Adds the given fields to the database for this module if it has not already
		// been created. WARNING: if the module has already been created with the name
		// given in the Module constructor you must delete the old module before the
		// new one will be created. This may have an adverse effect on services.
		onlinenic::$module->addDBField("varchar(255)", "memberid", "Member ID");
		onlinenic::$module->addDBField("varchar(255)", "password", "Password");
		onlinenic::$module->addDBField("varchar(5)", "testmode", "Test Mode", "true");
		onlinenic::$module->addDBField("varchar(5)", "lock", "Lock", "true");
		onlinenic::$module->addDBField("varchar(255)", "ns1", "NS1");
		onlinenic::$module->addDBField("varchar(255)", "ns2", "NS2");
		
		
		// Options for creating a new module row
		// Example: onlinenic module may store multiple different servers. The HTML Fields below
		// allow you to create/edit a server for the onlinenic module
		// NOTE: The HTML Fields will appear in the order defined here on the module setup/edit pages
		onlinenic::$module->addModuleHTMLField("text", "Member ID", "memberid");
		onlinenic::$module->addModuleHTMLField("text", "Password", "password");
		onlinenic::$module->addModuleHTMLField("select", "Test Mode", "testmode");
			onlinenic::$module->addModuleHTMLSelectOption("testmode", "Yes", "true");
			onlinenic::$module->addModuleHTMLSelectOption("testmode", "No", "false");
		onlinenic::$module->addModuleHTMLField("select", "Lock Domains", "lock");
			onlinenic::$module->addModuleHTMLSelectOption("lock", "Yes", "true");
			onlinenic::$module->addModuleHTMLSelectOption("lock", "No", "false");
		onlinenic::$module->addModuleHTMLField("text", "NS1", "ns1");
		onlinenic::$module->addModuleHTMLField("text", "NS2", "ns2");
		
		
		// Specify which field from the module table to display in the drop down and give it a friendly name
		// By default items will be shown by ID and have the friendly name of "Module ID".
		// This appears when adding or editing a service for a user.
		onlinenic::$module->setModuleRowSelect("OnlineNIC Account", "memberid");
		
		// If the 3rd parameter is anything other than user1, user2, pass, opt1, opt2, it must be formatted as an element of the detail array.
		// ex. detail[emailaddress].  Note, any field other than user1, user2, pass, opt1, or opt2  will *NOT* be stored in the database,
		// and may only be used in this module file.
		// Fields that are shown to the admins when adding a service that uses this module from within the control panel
		onlinenic::$module->addServiceHTMLField("text", "Domain Name", "user1", "^[a-z0-9._%-]+\.[a-z]{2,6}$", "The Domain Name you entered does not appear to be valid. It should be lowercase and in the format: domain.com.");
		onlinenic::$module->addServiceHTMLField("text", "E-mail Address", "detail[email]", "^[a-z0-9._%-]+@[a-z0-9._%-]+\.[a-z]{2,6}$", "The E-mail address you entered does not appear to be valid.");
		onlinenic::$module->addServiceHTMLField("text", "First Name", "detail[fname]", "^.{2,}", "You must provide a valid First Name.");
		onlinenic::$module->addServiceHTMLField("text", "Last Name", "detail[lname]", "^.{2,}", "You must provide a valid Last Name.");
		onlinenic::$module->addServiceHTMLField("text", "Address 1", "detail[address1]", "^.{2,}", "You must provide a valid Address.");
		onlinenic::$module->addServiceHTMLField("text", "Address 2", "detail[address2]");
		onlinenic::$module->addServiceHTMLField("text", "City", "detail[city]", "^.{2,}", "You must provide a valid City.");
		onlinenic::$module->addServiceHTMLField("text", "State/Province", "detail[state]");
		onlinenic::$module->addServiceHTMLField("text", "Postal Code", "detail[postcode]");
		onlinenic::$module->addServiceHTMLField("text", "Country", "detail[country]", "^[a-zA-z]{2}$", "You must provide a two character Country Code.");
		onlinenic::$module->addServiceHTMLField("text", "Phone", "detail[phone]", "^[0-9\.\-\(\)\+ ]{10,}", "You must provide a valid Phone Number.");
		onlinenic::$module->addServiceHTMLField("text", "Fax", "detail[fax]");
		onlinenic::$module->addServiceHTMLField("text", "Organization", "detail[org]");
		
		// If the 3rd parameter is anything other than user1, user2, pass, opt1, opt2, then the field created will *NOT* be stored
		// in the database, and may only be used in this module file.
		// Fields that are shown to the user when adding a service that uses this module from within the control panel
		onlinenic::$module->addUserServiceHTMLField("text", "Domain Name", "user1", "^[a-z0-9._%-]+\.[a-z]{2,6}$", "The domain you entered does not appear to be valid. It should be lowercase and in the format: domain.com.");
		onlinenic::$module->addUserServiceHTMLField("text", "E-mail Address", "detail[email]", "^[a-z0-9._%-]+@[a-z0-9._%-]+\.[a-z]{2,6}$", "The E-mail address you entered does not appear to be valid.");
		onlinenic::$module->addUserServiceHTMLField("text", "First Name", "detail[fname]", "^.{2,}", "You must provide a valid First Name.");
		onlinenic::$module->addUserServiceHTMLField("text", "Last Name", "detail[lname]", "^.{2,}", "You must provide a valid Last Name.");
		onlinenic::$module->addUserServiceHTMLField("text", "Address 1", "detail[address1]", "^.{2,}", "You must provide a valid Address.");
		onlinenic::$module->addUserServiceHTMLField("text", "Address 2", "detail[address2]");
		onlinenic::$module->addUserServiceHTMLField("text", "City", "detail[city]", "^.{2,}", "You must provide a valid City.");
		onlinenic::$module->addUserServiceHTMLField("text", "State/Province", "detail[state]");
		onlinenic::$module->addUserServiceHTMLField("text", "Postal Code", "detail[postcode]");
		onlinenic::$module->addUserServiceHTMLField("text", "Country", "detail[country]", "^[a-zA-z]{2}$", "You must provide a valid two character Country Code.");
		onlinenic::$module->addUserServiceHTMLField("text", "Phone", "detail[phone]", "^[0-9\.\-\(\)\+ ]{10,}", "You must provide a valid Phone Number.");
		onlinenic::$module->addUserServiceHTMLField("text", "Fax", "detail[fax]");
		onlinenic::$module->addUserServiceHTMLField("text", "Organization", "detail[org]");
		
		// These displayed as tags and are usable when creating/editing a packages welcome e-mail
		onlinenic::$module->addServiceTag("user1", "domain");
		
		// These are the fields that may be edited when performing a local edit on this service
		onlinenic::$module->addServiceEditField("user1", "Domain");
		onlinenic::$module->addServiceEditField("plan", "Package/Term"); // Package/Term
		onlinenic::$module->addServiceEditField("dated", "Date Deleted");
		onlinenic::$module->addServiceEditField("datep", "Date Suspended");
		onlinenic::$module->addServiceEditField("dater", "Date Renews");
		onlinenic::$module->addServiceEditField("notes", "Notes");
		
		// Creates the module, adds the module to the database if the module table does not
		// already exist. WARNING: if a module has already been created and you attempt to
		// add additional fields they WILL NOT BE ADDED, and any refrence to those fields
		// WILL RESULT IN AN ERROR.
		onlinenic::$module->createModule();
	}

	// Returns the module object, this function MUST be present
	public function getModule() {
		return onlinenic::$module;
	}


	/*******************************************************************************
	********************************************************************************
	* This is the MAGIC function. This function automatically creates a service    *
	* for a user.                                                                  *
	*                                                                              *
	* IT MUST BE DEFINED HERE OR AN E-MAIL WILL BE SENT TO ALL SUBSCRIBED ADMINS   *
	* NOTIFYING THEM THAT THE SERVICE MUST BE MANUALLY CREATED.                    *
	*                                                                              *
	* IF THIS FUNCTION IS DEFINED AND RETURNS TRUE IT IS ASSUMED THAT IT PERFORMS  *
	* THE NECCESSARY ACTIONS TO AUTOMATICALLY ACTIVATE THE SERVICE.                *
	********************************************************************************
	*******************************************************************************/

	public function promodule($action, $serviceInfo, $packageInfo) {
		$conditions = array(array("field" => "id", "value" => $serviceInfo['mid']));
		$data = onlinenic::$module->getRows($conditions);

		// If this is a test transaction use the test account.
		if ($data[0]['testmode']) {
			$data[0]['memberid'] = onlinenic::$test_login;
			$data[0]['password'] = onlinenic::$test_password;
		}

		// Onlinenic should handle the formatting of phone numbers themselves but they don't... so lazy!
		$serviceInfo['detail']['phone'] = $this->formatPhone($serviceInfo['detail']['phone'], $serviceInfo['detail']['country']);
		if ($serviceInfo['detail']['fax'] != "")
			$serviceInfo['detail']['fax'] = $this->formatPhone($serviceInfo['detail']['fax'], $serviceInfo['detail']['country']);

		// Initialize connection
		$this->initializeConnection($data[0]);

		// Attempt to login to onlineNIC
		if (!$this->login($data[0]))
			return false;

		switch ($action) {
			case "add":
				if (strlen($serviceInfo['detail']['fax']) == 0)
					$serviceInfo['detail']['fax'] = $serviceInfo['detail']['phone'];
				if (strlen($serviceInfo['detail']['org']) == 0)
					$serviceInfo['detail']['org'] = $serviceInfo['detail']['fname'] . " " . $serviceInfo['detail']['lname'];
				
				if (DEMO)
					return $serviceInfo;
				
				// Register the contact
				$contactID = "";
				if (($contactID = $this->registerContact($data[0], $serviceInfo)) === false)
					return false;
				
				// Check that this domain is available, then add the domain
				if ($this->checkDomain($serviceInfo['user1']) == "false" && $this->addDomain($data[0], $serviceInfo, $contactID)) {
					
					// Set auto-renew
					$this->setAutoRenew($data[0], $serviceInfo['user1'], true);
					
					if ($data[0]['lock'] == "true") {
						// Lock the domain
						$this->lockDomain($data[0], $serviceInfo['user1']);
					}
				
					// Logout
					$this->logout($data[0]);
					
					return $serviceInfo;
				}
				break;
			case "remove":
				// Attempt to remove the domain if possible, otherwise turn off auto renew
				// The domain only can be deleted within 3 days upon the registration.
				// So if we can't delete it, we turn auto-renew off.
				if ($this->deleteDomain($data[0], $serviceInfo['user1']) || $this->setAutoRenew($data[0], $serviceInfo['user1'], "false")) {
					// Logout
					$this->logout($data[0]);
					
					return true;
				}
				break;
			case "suspend":
				// No action to perform.
				// Logout
				$this->logout($data[0]);
				return true;
			case "unsuspend":
				// No action to perform.
				// Logout
				$this->logout($data[0]);
				return true;
		}

		// Logout
		$this->logout($data[0]);

		return false;
	}


	// Checks if the given domain is available through onlinenic
	public function checkDomain($domain) {
		$data = onlinenic::$module->getRows();
		$data = $data[0];

		// If this is a test transaction use the test account.
		if ($data['testmode']) {
			$data['memberid'] = onlinenic::$test_login;
			$data['password'] = onlinenic::$test_password;
		}

		$clTRID = rand(100000, 999999);
		$type = $this->getDomainType($domain);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "chkdomain" . $type . $domain);

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:iana:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:iana:xml:ns:epp-1.0 epp-1.0.xsd">
	<command>
		<check>
			<domain:check xmlns:domain="urn:iana:xml:ns:domain-1.0" xsi:schemaLocation="urn:iana:xml:ns:domain-1.0 domain-1.0.xsd">
				<domain:type>{$type}</domain:type>
				<domain:name>{$domain}</domain:name>
			</domain:check>
		</check>
		<unspec/>
		<clTRID>{$clTRID}</clTRID>
		<chksum>{$checkSum}</chksum>
	</command>
</epp>
EOT;

		if ($this->fp < 1) {
			$this->initializeConnection($data);
			$this->login($data);
		}

		$response = $this->call($xml);

		// Successfull call returns result code 1000
		if ($this->successResponse($response)) {
			preg_match("/\<domain:cd x=\"(.+)\"\>/", $response, $status);
			if ($status[1] == "+")
				return "true"; // Domain was found
		}
		return "false"; // Domain not found
	}


	/* ------------------------------------------------------------------------------------------------
   The following are support functions for this module
	--------------------------------------------------------------------------------------------------*/

	private function login(&$data) {
		$clTRID = rand(100000, 999999);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "login");

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp>
	<command>
		<creds>
			<clID>{$data['memberid']}</clID>
			<options>
				<version>1.0</version>
				<lang>en</lang>
			</options>
		</creds>
		<clTRID>{$clTRID}</clTRID>
		<login>
			<chksum>{$checkSum}</chksum>
		</login>
	</command>
</epp>
EOT;
		$response = $this->call($xml);

		return $this->successResponse($response);
	}

	private function logout(&$data) {
		$clTRID = rand(100000, 999999);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "logout");

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp>
	<command>
		<logout/>
		<unspec/>
		<clTRID>{$clTRID}</clTRID>
		<chksum>{$checkSum}</chksum>
	</command>
</epp>
EOT;
		$response = $this->call($xml);

		return $this->successResponse($response);
	}

	private function registerContact(&$data, &$serviceInfo) {
		$clTRID = rand(100000, 999999);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "login");
		$pw = substr(md5(mt_rand(1000, 9999)), 0, 4) . mt_rand(1000, 9999);
		$unspec = ($tld == "us" ? "<unspec>AppPurpose=P3 NexusCategory=C11</unspec>" : "");

		$type = $this->getDomainType($serviceInfo['user1']);

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8" standalone="no" ?>
<epp xmlns="urn:iana:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:iana:xml:ns:epp-1.0 epp-1.0.xsd">
	<command>
		<create>
			<contact:create xmlns:contact="urn:iana:xml:ns:contact-1.0" xsi:schemaLocation="urn:iana:xml:ns:con tact-1.0 contact-1.0.xsd">
				<contact:domaintype>{$type}</contact:domaintype>
				<contact:ascii>
					<contact:name>{$serviceInfo['detail']['fname']} {$serviceInfo['detail']['lname']}</contact:name>
					<contact:org>{$serviceInfo['detail']['org']}</contact:org>
					<contact:addr>
						<contact:street1>{$serviceInfo['detail']['address1']}</contact:street1>
						<contact:street2>{$serviceInfo['detail']['address2']}</contact:street2>
						<contact:city>{$serviceInfo['detail']['city']}</contact:city>
						<contact:sp>{$serviceInfo['detail']['state']}</contact:sp>
						<contact:pc>{$serviceInfo['detail']['postcode']}</contact:pc>
						<contact:cc>{$serviceInfo['detail']['country']}</contact:cc>
					</contact:addr>
				</contact:ascii>
				<contact:voice>{$serviceInfo['detail']['phone']}</contact:voice>
				<contact:fax>{$serviceInfo['detail']['fax']}</contact:fax>
				<contact:email>{$serviceInfo['detail']['email']}</contact:email>
				<contact:pw>{$pw}</contact:pw>
			</contact:create>
		</create>
		{$unspec}
		<clTRID>{$clTRID}</clTRID>
		<chksum>{$checkSum}</chksum>
	</command>
</epp>
EOT;
		$response = $this->call($xml);

		if ($this->successResponse($response)) {
			preg_match("/\<contact:id\>(.*)\<\/contact:id\>/", $response, $contactID);
			return $contactID[1];
		}
		return false;
	}


	private function addDomain(&$data, &$serviceInfo, &$contactID) {
		$clTRID = rand(100000, 999999);
		$term = ($serviceInfo['term'] > 12 ? floor($serviceInfo['term']/12) : 1);
		$pw = substr(md5(mt_rand(1000, 9999)), 0, 4) . mt_rand(1000, 9999);
		$type = $this->getDomainType($serviceInfo['user1']);

		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "crtdomain" . $type . $serviceInfo['user1'] .
			$term . $data['ns1'] . $data['ns2'] . $contactID . $contactID . $contactID . $contactID . $pw);

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8"?>
<epp>
     <command>
	  <create>
	  	<domain:create>
			<domain:type>{$type}</domain:type>
			<domain:name>{$serviceInfo['user1']}</domain:name>
			<domain:period>{$term}</domain:period>
			<domain:ns1>{$data['ns1']}</domain:ns1>
			<domain:ns2>{$data['ns2']}</domain:ns2>
			<domain:registrant>{$contactID}</domain:registrant>
			<domain:contact type="admin">{$contactID}</domain:contact>
			<domain:contact type="tech">{$contactID}</domain:contact>
			<domain:contact type="billing">{$contactID}</domain:contact>
			<domain:authInfo type="pw">{$pw}</domain:authInfo>
		</domain:create>
	  </create>
	  <clTRID>{$clTRID}</clTRID>
	  <chksum>{$checkSum}</chksum>
     </command>
</epp>
EOT;
		$response = $this->call($xml);

		return $this->successResponse($response);
	}

	private function initializeConnection(&$data) {
		$url = ($data['testmode'] == "true" ? onlinenic::$test_url : onlinenic::$live_url);
		self::$module->logData("Initialize Connection to: " . $url . ":" . onlinenic::$port, "input", true);
		
		$this->fp = fsockopen($url, onlinenic::$port, $errno, $errstr, 90);

		$i=0;
		while (!feof($this->fp)) {
			$line = fgets($this->fp, 2);
			$result .= $line;
			if (preg_match("/<\/epp>$/i", substr($result, -6, 6)))
				break;
			if ($i++ > 4096)
				break;
		}
		self::$module->logData($result, "output", (strlen($result) > 0 ? true : false));
		return $result;
	}

	private function call(&$xml) {
		self::$module->logData($xml, "input", true);
		
		fputs($this->fp, $xml);

		while (!feof($this->fp)) {
			$line = fgets($this->fp, 2);
			$result .= $line;
			if (preg_match("/<\/epp>$/i", substr($result, -6, 6)))
				break;
			if ($i++ > 4096)
				break;
		}
		self::$module->logData($result, "output", $this->successResponse($result));
		return $result;
	}

	private function getDomainType($domain) {
		preg_match('/^([a-z0-9]+[a-z0-9\-]*[a-z0-9]+)\.([a-z]+[a-z\.]*[a-z]+)$/i', $domain, $type);
		$sld = $type[1];
		$tld = $type[2];
		
		switch ($tld) {
			default:
				return "0";
			case "biz":
				return "800";
			case "info":
				return "805";
			case "us":
				return "806";
			case "in":
				return "808";
			case "cn":
				return "220";
		}
	}

	private function setAutoRenew(&$data, &$domain, $active) {
		$clTRID = rand(100000, 999999);
		$type = $this->getDomainType($domain);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "upddomain" . $type . $domain);

		$xml =<<<EOT
<?xml version="1.0" encoding="UTF-8"?>
<epp>
     <command>
     	  <update>
	  	<domain:update>
		<domain:type>{$type}</domain:type>
		<domain:name>{$domain}</domain:name>
		<domain:[add/rem]>
		<domain:status s="autoRenew"/>
		</domain:[add/rem]>
		</domain:update>
	  </update>
	  <clTRID>{$clTRID}</clTRID>
	  <chksum>{$checkSum}</chksum>
     </command>
</epp>
EOT;
		$xml = str_replace("[add/rem]", ($active ? "add" : "rem"), $xml);

		$response = $this->call($xml);

		return $this->successResponse($response);
	}

	private function lockDomain(&$data, &$domain) {
		$clTRID = rand(100000, 999999);
		$type = $this->getDomainType($domain);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "upddomain" . $type . $domain);

		$xml =<<< EOT
<?xml version="1.0" encoding="UTF-8"?>
<epp>
     <command>
	  <update>
		<domain:update>
		<domain:type>{$type}</domain:type>
		<domain:name>{$domain}</domain:name>
		<domain:add>
		<domain:status s="clientTransferProhibited"/>
		</domain:add>
		</domain:update>
	  </update>
	  <clTRID>{$clTRID}</clTRID>
	  <chksum>{$checkSum}</chksum>
     </command>
</epp>
EOT;
		$response = $this->call($xml);

		return $this->successResponse($response);
	}


	private function deleteDomain(&$data, &$domain) {
		$clTRID = rand(100000, 999999);
		$type = $this->getDomainType($domain);
		$checkSum = md5($data['memberid'] . md5($data['password']) . $clTRID . "deldomain" . $type . $domain);

		$xml =<<< EOT
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:iana:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:iana:xml:ns:epp-1.0 epp-1.0.xsd">
     <command>
	  <delete>
		<domain:delete xmlns:domain="urn:iana:xml:ns:domain-1.0" xsi:schemaLocation="urn:iana:xml:ns:domain-1.0 domain-1.0.xsd">
		<domain:type>{$type}</domain:type>
		<domain:name>{$domain}</domain:name>
		</domain:delete>
	  </delete>
	  <unspec/>
	  <clTRID>{$clTRID}</clTRID>
	  <chksum>{$checkSum}</chksum>
     </command>
</epp>
EOT;
		$response = $this->call($xml);

		return $this->successResponse($response);
	}
	
	private static function successResponse($response) {
		return preg_match("/<result code=\"1[0-9]+\">/i", $response);
		
	}
	
	private static function formatPhone($number, $country) {
		$number = preg_replace("/[^\d]/", "", $number);
		if ($country == "US")
			$code = 1;
		else {
			preg_match("/(\+?\d{1,3})?\.?(\d+)/", $number, $matches);
			$code = $matches[1];
			if ($code == "") {
				if (strlen($matches[2]) > 10) {
					$n = strlen($matches[2])-10;
					$code = substr($matches[2], 0, $n);
				}
				else
					$code = "1";
			}
			else {
				$code = str_replace("+", "", $code);
				
				if (strlen($matches[2]) <= 8) {
					$n = (7-strlen($matches[2]));
					$code = substr($code, 0, strlen($code)+$n);
				}
			}
		}
		
		$number = preg_replace("/^(" . $code . ")(\d+)/", '+\1.\2', $number);
		if ($number[0] == '+')
			return $number;
		
		return "+" . $code . $number;
	}
}
?>