<?php
class whois {
	private static $lookupTable;

	public function __construct() {
		$temp = explode("\n", file_get_contents(dirname(__FILE__) . "/whois.txt"));
		for ($i=0; $i<count($temp); $i++) {
			$whois_temp = explode("|", $temp[$i]);
			whois::$lookupTable[$whois_temp[0]]['server'] = trim($whois_temp[1]);
			whois::$lookupTable[$whois_temp[0]]['response'] = trim($whois_temp[2]);
			
			unset($whois_temp);
		}
		unset($temp);
	}

	// @vars domain string, tld string.
	// @returns true when availabe (or cannot determine), false otherwise
	public function lookup($domain, $tld) {

		// If upper case, assume case should be preserved
		$case = (whois::$lookupTable[$tld]['response'] == strtoupper(whois::$lookupTable[$tld]['response']) ? "" : "i");

		if (!preg_match("/^([a-z0-9]+-*[a-z0-9]+){1,63}$/i", $domain))
			return false;

		// Send request via HTTP
		//if (eregi("HTTPREQUEST", whois::$lookupTable[$tld]['response'])) {
		if (preg_match("/HTTPREQUEST/i", whois::$lookupTable[$tld]['response'])) {
			$temp = explode("-", whois::$lookupTable[$tld]['response']); 
			whois::$lookupTable[$tld]['response'] = $temp[1];
			
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, whois::$lookupTable[$tld]['server'] . $domain . $tld);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($ch, CURLOPT_TIMEOUT, 10);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$response = curl_exec($ch);
			curl_close($ch);            
			
			//if (eregi(whois::$lookupTable[$tld]['response'], $response))
			if (preg_match("/" . whois::$lookupTable[$tld]['response'] . "/" . $case, $response))
				return true;
			return false;
		}
		// Send request via port 43
		else {
			$whois_server = @fsockopen(whois::$lookupTable[$tld]['server'], 43, $errno, $errstr, 10);

			if ($whois_server) {
				@fputs($whois_server, $domain . $tld . "\r\n");
				@socket_set_timeout ($whois_server, 10);
				while (!@feof ($whois_server))
					$response .= @fread($whois_server, 1024);
				@fclose ($whois_server);

				//if (eregi(whois::$lookupTable[$tld]['response'], $response))
				if (preg_match("/" . whois::$lookupTable[$tld]['response'] . "/" . $case, $response))
					return true;
				return false;
			}                                                 
		}
		return true;
	}
}

?>