
function check_uncheck_all(id, length) {
	var check = false;
	for (var i=0; i<length; i++) {
		var x = document.getElementById(id + i);
		// if one element is unchecked, we must want to check all
		if (x.checked == false) {
			check = true;
			break;
		}
	}
	// check, or uncheck, all
	for (var i=0; i<length; i++) {
		var x = document.getElementById(id + i);
		x.checked = check;
	}
}

function check_uncheck(name, exclude) {
	var fields = document.getElementsByName(name);
	var check = false;
	
	for (var i=0; i<fields.length; i++) {
		if (fields[i].value == exclude) {
			check = fields[i].checked ? false : true;
			break;
		}
	}
	
	for (var i=0; i<fields.length; i++) {
		if (fields[i].value == exclude)
			continue;
		
		if (!check)
			fields[i].checked = false;
	}
}

function addAttachment(element) {
	element = document.getElementById(element);
	
	var li = document.createElement('li');
	element.appendChild(li);
	
	var label = document.createElement('label');
	label.innerHTML = "&nbsp;";
	
	li.appendChild(label);
	
	var span = document.createElement('span');
	
	var input = document.createElement('input');
	input.setAttribute('name', 'attach[]');
	input.setAttribute('type', 'file');

	span.appendChild(input);
	li.appendChild(span);
}

// Adds an element to the new ticket form, to specify what area
function addElement(addOn) {

	if (document.getElementById('area').value == addOn) {
		var areaname = document.getElementById('areaname');
		areaname.innerHTML = addOn + ":";
		
		var areadetail = document.getElementById('areadetail');
		var input = document.createElement('input');
		input.setAttribute('name', 'areainput');
		input.setAttribute('type', 'text');
		input.setAttribute('id', 'areainput');
		input.setAttribute('class', 'large');
		// For IE cross support...
		input.setAttribute('className', 'large');
		
		areadetail.appendChild(input);
	}
	// get rid of the element
	else if (typeof document.getElementById('areadetail') == 'object') {
		var areaname = document.getElementById('areaname');
		areaname.innerHTML = "";
		
		var areadetail = document.getElementById('areadetail');
		var input = document.getElementById('areainput');
		
		if (input)
			areadetail.removeChild(input);
	}
	return true;
}

// Moves the select item from one select field to another
function moveSelected(from, to, type) {
	from = document.getElementById(from);
	to = document.getElementById(to);
	
	var fromlength = from.options.length;
	var i=0;
	for (; i<fromlength; i++) {
		var opt = from.options[i];
		if (type == "all" || opt.selected) {
			var index=0;
			if (!(to == null && to.options == null))
				index = to.options.length;
			to.options[index] = new Option(opt.text, opt.value, false, false);
		}
	}
	
	for (i=(fromlength-1); i>=0; i--) {
		var opt = from.options[i];
		if (type == "all" || opt.selected) {
			from.options[i] = null;
		}
	}
}

// Selects all options in the multi select field given
function selectAllOptions(from) {
	from = document.getElementById(from);
	
	if (from == null && from.options == null)
		return;
	
	for (var i=0; i<from.options.length; i++)
		from.options[i].selected = true;
}


// Selects the radio element to enable and disables the other(s).
function toggleSelected(enable) {
	document.getElementById(enable).checked = true;
}

function toggleDisabled(id, disabled) {
	var element = document.getElementById(id);
	
	element.disabled = disabled;
}

// Appends the given text to the given element id
function appendText(id, text) {
	if (text.length == 0)
		return;

	var element = document.getElementById(id);

	element.value += (element.value.length > 0 ? "\n" : "") + text;
}

// Shows or hides the given container
function show_hide(hidden_id, display_id, show_text, hide_text) {
	var hidden = document.getElementById(hidden_id);
	var display = document.getElementById(display_id);
	
	if (hidden.style.display == 'none') {
		hidden.style.display = 'inline';
		display.innerHTML = hide_text;
	}
	else {
		hidden.style.display = 'none';
		display.innerHTML = show_text;
	}                                    
}

function addInnerHTML(id, text) {
	document.getElementById(id).innerHTML = text;
}